package org.rcisoft.alibaba.faceVerify.controller;


/*固定导入*/

import com.aliyun.cloudauth20190307.models.InitFaceVerifyRequest;
import io.swagger.v3.oas.annotations.Operation;
import jakarta.servlet.http.HttpServletRequest;
import org.rcisoft.alibaba.faceVerify.service.FaceVerifyService;
import org.rcisoft.business.memInfo.entity.MemInfo;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.controller.CyPaginationController;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
* Created by cy on 2024年12月20日 下午3:35:34.
*/
@RestController
@RequestMapping("/faceVerify")
public class FaceVerifyController extends CyPaginationController<MemInfo> {


    @Autowired
    private FaceVerifyService faceVerifyService;


    @CyOpeLogAnno(title = "system-发起认证请求", businessType = CyLogTypeEnum.OTHER)
    @Operation(summary="发起认证请求", description="发起认证请求")
    @PostMapping(value = "/initFaceVerify")
    public CyResult initFaceVerify(@RequestBody MemInfo info, HttpServletRequest request) {
        Map<String,String> data = faceVerifyService.initFaceVerify(request,info);
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
                data);
    }

    @CyOpeLogAnno(title = "system-获取认证详细数据", businessType = CyLogTypeEnum.OTHER)
    @Operation(summary="获取认证详细数据", description="获取认证详细数据")
    @PostMapping(value = "/describeFaceVerify")
    public CyResult describeFaceVerify(@RequestBody InitFaceVerifyRequest request) {
        Map<String,String> data = faceVerifyService.describeFaceVerify(request);
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                data);
    }

//    @CyOpeLogAnno(title = "system-获取认证详细数据", businessType = CyLogTypeEnum.OTHER)
    @Operation(summary="实人认证回调地址", description="实人认证回调地址")
    @GetMapping(value = "/callbackFaceVerify")
    public void callbackFaceVerify(@RequestParam String callbackToken,@RequestParam String certifyId,@RequestParam String passed) {
        faceVerifyService.callbackFaceVerify(callbackToken,certifyId,passed);
    }
}
